<?php

namespace Drupal\niobi_app\Access;

use Drupal\Core\Routing\Access\AccessInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Access\AccessResult;
use Drupal\Core\Routing\RouteMatchInterface;
use Drupal\niobi_app\Entity\NiobiApplicationWorkflow;
use Symfony\Component\Routing\Route;
use Symfony\Component\HttpFoundation\Request;


class NiobiAppWorkflowAdmin implements AccessInterface {

  public function access(Route $route, RouteMatchInterface $route_match, AccountInterface $account) {

    $workflow_id = $route_match->getParameter('niobi_application_workflow');

    if($workflow_id) {
      $workflow = NiobiApplicationWorkflow::load($workflow_id);
      $workflow_author = $workflow->getOwner();
      $is_author = $workflow_author->id() === $account->id();
      $permission = $account->hasPermission('administer niobi_app applications');
      return $is_author || $permission ? AccessResult::allowed() : AccessResult::forbidden();
    }
    // If this isn't an application workflow or related view, this check doesn't apply.
    return AccessResult::allowed();
  }
}